#include <stdio.h>
#include <stdlib.h>

typedef struct {
  char pismeno[201];
  unsigned char skrt[200];
} TRadek;

char **Slovnik;                  /* Vyskrtavana slova */
int Obsah[28];                   /* Obsah slovniku */
TRadek Plocha[200];              /* Hraci plocha */
int rozx, rozy;                  /* Rozmer hraci plochy */

int NajdiSlovo(char *slovo, int x, int y, int smer)
{
  int dalsix = x, dalsiy = y;
  int result = 0;
  
  if (slovo[0] != 0) {
    if (slovo[0] == Plocha[y].pismeno[x]) {
      Plocha[y].skrt[x] |= 2;

      switch (smer) {
      case 0 :  /* Sever */
        dalsiy--;
        break;
      case 1 :  /* Severo-vychod */
        dalsix++;
        dalsiy--;
        break;
      case 2 :  /* Vychod */
        dalsix++;
        break;
      case 3 :  /* Jiho-vychod */
        dalsix++;
        dalsiy++;
        break;
      case 4 :  /* Jih */
        dalsiy++;
        break;
      case 5 :  /* Jiho-zapad */
        dalsix--;
        dalsiy++;
        break;
      case 6 :  /* Zapad */
        dalsix--;
        break;
      case 7 :  /* Severo-zapad */
        dalsix--;
        dalsiy--;
        break;
      }
      if (dalsiy < 0) dalsiy = rozy - 1;
      if (dalsiy >= rozy) dalsiy = 0;
      if (dalsix < 0) dalsix = rozx - 1;
      if (dalsix >= rozx) dalsix = 0;
    
      if ((result = NajdiSlovo(&slovo[1], dalsix, dalsiy, smer)) == -1) {
        /* Nektere z dalsich pismen nebylo nalezeno */
        Plocha[y].skrt[x] ^= 2;
      } else {
        /* V plose byl nalezen i zbytek slova */
        Plocha[y].skrt[x] = 1;
      }

    } else {
      /* Pismeno ze slova neni v plose */
      result = -1;
    }
  }
  return(result);
}

void osmismerka(void)
{
  int posx, posy;
  int pocslov, slovo;
  int smer, index;
  char *p_c;
  
  scanf("%d %d", &rozy, &rozx);
  smer = getchar();
  for (posy = 0; posy < rozy; posy++) {
    gets(Plocha[posy].pismeno);
    for (posx = 0; posx < rozx; posx++) {
      Plocha[posy].skrt[posx] = 0;
    }
  }

  scanf("%d", &pocslov);
  smer = getchar();
  for (posx = 0; posx < 28; posx++)
    Obsah[posx] = 0;
  Slovnik = (char **) malloc(pocslov*sizeof(char*));
  for (slovo = 0; slovo < pocslov; slovo++) {
    p_c = (char *) malloc(21 * sizeof(char));
    gets(p_c);
    /* Zatridime do slovniku */
    index = p_c[0]-'a';
    for (posx = Obsah[index]; posx <= Obsah[index+1]; posx++) {
      smer = 0;
      if (Slovnik[posx] == NULL ||
          (smer = strcmp(p_c, Slovnik[posx])) < 0) {
        printf("Nalezeno umisteni.\n");
        if (smer > 0) {
          for (posy = pocslov-1; posy > posx; posy--) {
	    printf("%s -> %s\n", Slovnik[posy-1], Slovnik[posy]);
            Slovnik[posy] = Slovnik[posy-1];
	  }
	}
	Slovnik[posx] = p_c;
	for (posy = p_c[0]-'a'; posy < 28; posy++)
	  Obsah[posy]++;
	break;
      }
      if (smer == 0) {
        printf("Duplicitni polozka '%s'.\n", p_c);
        free((void *) p_c);
	break;
      }
    }
  }
  /* Kontrola slovniku */
  for (slovo = 0; slovo < pocslov; slovo++)
    printf("%s\n", Slovnik[slovo]);
  
  for (posy = 0; posy < rozy; posy++) {
    for (posx = 0; posx < rozx; posx++) {
      index = Plocha[posy].pismeno[posx] - 'a';
      for (slovo = Obsah[index]; slovo < Obsah[index+1]; slovo++) {
        for (smer = 0; smer < 8; smer++) {
          NajdiSlovo(&Slovnik[slovo][1], posx, posy, smer);
	}
      }
    }
  }
  
  for (posy = 0; posy < rozy; posy++) {
    for (posx = 0; posx < rozx; posx++) {
      if (Plocha[posy].skrt[posx] == 0)
        putchar(Plocha[posy].pismeno[posx]);
    }
  }
  printf("\n");

  for (slovo = 0; slovo < pocslov; slovo++) {
    free((void *) Slovnik[slovo]);
  }
  free((void *) Slovnik);
}

int main(void)
{
  int zadani;
  
  scanf("%d", &zadani);
  for (; zadani > 0; zadani--)
    osmismerka();
  return(0);
}
